

// This C++ file was created by SanEditor

#include "Atomic/Attack_Evolution/Attack_EvolutionSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         Attack_EvolutionSAN Constructor             
******************************************************************/


Attack_EvolutionSAN::Attack_EvolutionSAN(){


  Activity* InitialActionList[1]={
    &EvolveInterval  // 0
  };

  BaseGroupClass* InitialGroupList[1]={
    (BaseGroupClass*) &(EvolveInterval)
  };

  EvolutionEnabled = new Place("EvolutionEnabled" ,evolution_enabled);
  evolveCounter = new Place("evolveCounter" ,0);
  ChannelAttackList_state temp_ChanAttackListChannelAttackList = {0,{{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}}};
  ChanAttackList = new ChannelAttackList("ChanAttackList",temp_ChanAttackListChannelAttackList);
  BaseStateVariableClass* InitialPlaces[3]={
    EvolutionEnabled,  // 0
    evolveCounter,  // 1
    ChanAttackList   // 2
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("Attack_Evolution", 3, InitialPlaces, 
                        0, InitialROPlaces, 
                        1, InitialActionList, 1, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[3][2]={ 
    {0,0}, {1,0}, {2,0}
  };
  for(int n=0;n<3;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[1][2]={ 
    {0,0}
  };
  for(int n=0;n<1;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<1;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void Attack_EvolutionSAN::CustomInitialization() {

}
Attack_EvolutionSAN::~Attack_EvolutionSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void Attack_EvolutionSAN::assignPlacesToActivitiesInst(){
}
void Attack_EvolutionSAN::assignPlacesToActivitiesTimed(){
  EvolveInterval.EvolutionEnabled = (Place*) LocalStateVariables[0];
  EvolveInterval.evolveCounter = (Place*) LocalStateVariables[1];
  EvolveInterval.ChanAttackList = (ChannelAttackList*) LocalStateVariables[2];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================EvolveIntervalActivity========================*/

Attack_EvolutionSAN::EvolveIntervalActivity::EvolveIntervalActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("EvolveInterval",0,Exponential, RaceEnabled, 3,1, false);
}

Attack_EvolutionSAN::EvolveIntervalActivity::~EvolveIntervalActivity(){
  delete[] TheDistributionParameters;
}

void Attack_EvolutionSAN::EvolveIntervalActivity::LinkVariables(){
  EvolutionEnabled->Register(&EvolutionEnabled_Mobius_Mark);
  evolveCounter->Register(&evolveCounter_Mobius_Mark);

}

bool Attack_EvolutionSAN::EvolveIntervalActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(EvolutionEnabled_Mobius_Mark)) >=1));
  return NewEnabled;
}

double Attack_EvolutionSAN::EvolveIntervalActivity::Rate(){
  return(evolutionInterval);
  return 1.0;  // default rate if none is specified
}

double Attack_EvolutionSAN::EvolveIntervalActivity::Weight(){ 
  return 1;
}

bool Attack_EvolutionSAN::EvolveIntervalActivity::ReactivationPredicate(){ 
  return false;
}

bool Attack_EvolutionSAN::EvolveIntervalActivity::ReactivationFunction(){ 
  return false;
}

double Attack_EvolutionSAN::EvolveIntervalActivity::SampleDistribution(){
  return TheDistribution->Exponential((evolutionInterval));
}

double* Attack_EvolutionSAN::EvolveIntervalActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int Attack_EvolutionSAN::EvolveIntervalActivity::Rank(){
  return 1;
}

BaseActionClass* Attack_EvolutionSAN::EvolveIntervalActivity::Fire(){
  (*(EvolutionEnabled_Mobius_Mark))--;
  int i, count = 0;
for(i=0;i<20;i++)
  {
    if(ChanAttackList->AttacksApplied->Index(i)->successProb->Mark() > (double)(0.0))
      {
	 // Increase the AttackRate by attackRateIncrement
	 cout << "\n\nEvolveGate: Rate change" << "\nFR[" << i << "] current rate: " << ChanAttackList->AttacksApplied->Index(i)->AttackRate->Mark(); 
	 ChanAttackList->AttacksApplied->Index(i)->AttackRate->Mark() *= ((double)(1.0) + attackRateIncrement);
	 cout << " New rate assigned: " << ChanAttackList->AttacksApplied->Index(i)->AttackRate->Mark();
      }
    else
      {
	 // Enable one additional attack.
	 if(count == 0)
	   {
	     cout << "\n\nEvolveGate: Enable a new FR" << "\nFR[" << i << "] current rate: " << ChanAttackList->AttacksApplied->Index(i)->AttackRate->Mark(); 
	     ChanAttackList->AttacksApplied->Index(i)->successProb->Mark() = 1;
	     count++;
	     cout << "\ncount = " << count;
	   }
      }
  };
  (*(EvolutionEnabled_Mobius_Mark))++;
  (*(evolveCounter_Mobius_Mark))++;
  return this;
}

