

// This C++ file was created by SanEditor

#include "Atomic/system_state/system_stateSAN.h"

#include <stdlib.h>
#include <iostream>

#include <math.h>


/*****************************************************************
                         system_stateSAN Constructor             
******************************************************************/


system_stateSAN::system_stateSAN(){


  Demand_RateGroup.initialize(2, "Demand_RateGroup");
  Demand_RateGroup.appendGroup((BaseGroupClass*) &Demand_Rate_case1);
  Demand_RateGroup.appendGroup((BaseGroupClass*) &Demand_Rate_case2);

  Activity* InitialActionList[4]={
    &Set_FRs, //0
    &UpdateDoIt, //1
    &Demand_Rate_case1, //2
    &Demand_Rate_case2  // 3
  };

  BaseGroupClass* InitialGroupList[3]={
    (BaseGroupClass*) &(Demand_RateGroup), 
    (BaseGroupClass*) &(Set_FRs), 
    (BaseGroupClass*) &(UpdateDoIt)
  };

  FR_Init = new Place("FR_Init" ,1);
  Init_Ch1 = new Place("Init_Ch1" ,0);
  Init_Ch2 = new Place("Init_Ch2" ,0);
  UpdateCounter = new Place("UpdateCounter" ,0);
  SysUpdate = new Place("SysUpdate" ,0);
  Mutex = new Place("Mutex" ,0);
  Demands_Enabled = new Place("Demands_Enabled" ,1);
  SystemFailure = new Place("SystemFailure" ,0);
  channelAttacked = new Place("channelAttacked" ,0);
  Ch2_slave = new Place("Ch2_slave" ,0);
  FR_description_state temp_FR_DefinitionFR_Arrayvalue = {0,0};
  FR_Definition = new FR_Array("FR_Definition",temp_FR_DefinitionFR_Arrayvalue);
  channelState_state temp_Ch1_StatechannelState = {0,0,0,0,0,{{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}},0};
  Ch1_State = new channelState("Ch1_State",temp_Ch1_StatechannelState);
  channelState_state temp_Ch2_StatechannelState = {0,0,0,0,0,{{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}},0};
  Ch2_State = new channelState("Ch2_State",temp_Ch2_StatechannelState);
  double temp_SystemPfddouble = 0;
  SystemPfd = new ExtendedPlace<double>("SystemPfd",temp_SystemPfddouble);
  ChannelAttackList_state temp_Ch1_attack_listChannelAttackList = {0,{{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}}};
  Ch1_attack_list = new ChannelAttackList("Ch1_attack_list",temp_Ch1_attack_listChannelAttackList);
  ChannelAttackList_state temp_Ch2_attack_listChannelAttackList = {0,{{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}}};
  Ch2_attack_list = new ChannelAttackList("Ch2_attack_list",temp_Ch2_attack_listChannelAttackList);
  BaseStateVariableClass* InitialPlaces[16]={
    FR_Init,  // 0
    Init_Ch1,  // 1
    Init_Ch2,  // 2
    UpdateCounter,  // 3
    SysUpdate,  // 4
    Mutex,  // 5
    Demands_Enabled,  // 6
    SystemFailure,  // 7
    channelAttacked,  // 8
    Ch2_slave,  // 9
    FR_Definition,  // 10
    Ch1_State,  // 11
    Ch2_State,  // 12
    SystemPfd,  // 13
    Ch1_attack_list,  // 14
    Ch2_attack_list   // 15
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("system_state", 16, InitialPlaces, 
                        0, InitialROPlaces, 
                        4, InitialActionList, 3, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[20][2]={ 
    {0,0}, {1,0}, {2,0}, {9,0}, {11,0}, {12,0}, {13,0}, {14,0}, 
    {15,0}, {5,0}, {10,0}, {4,1}, {3,1}, {11,1}, {8,1}, {12,1}, 
    {13,1}, {10,1}, {6,2}, {7,3}
  };
  for(int n=0;n<20;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[4][2]={ 
    {0,0}, {4,1}, {7,2}, {7,3}
  };
  for(int n=0;n<4;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<4;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void system_stateSAN::CustomInitialization() {

}
system_stateSAN::~system_stateSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void system_stateSAN::assignPlacesToActivitiesInst(){
  Set_FRs.FR_Init = (Place*) LocalStateVariables[0];
  Set_FRs.Init_Ch1 = (Place*) LocalStateVariables[1];
  Set_FRs.Init_Ch2 = (Place*) LocalStateVariables[2];
  Set_FRs.Ch2_slave = (Place*) LocalStateVariables[9];
  Set_FRs.Ch1_State = (channelState*) LocalStateVariables[11];
  Set_FRs.Ch2_State = (channelState*) LocalStateVariables[12];
  Set_FRs.SystemPfd = (ExtendedPlace<double>*) LocalStateVariables[13];
  Set_FRs.Ch1_attack_list = (ChannelAttackList*) LocalStateVariables[14];
  Set_FRs.Ch2_attack_list = (ChannelAttackList*) LocalStateVariables[15];
  Set_FRs.Mutex = (Place*) LocalStateVariables[5];
  Set_FRs.FR_Definition = (FR_Array*) LocalStateVariables[10];
  UpdateDoIt.SysUpdate = (Place*) LocalStateVariables[4];
  UpdateDoIt.UpdateCounter = (Place*) LocalStateVariables[3];
  UpdateDoIt.Ch1_State = (channelState*) LocalStateVariables[11];
  UpdateDoIt.channelAttacked = (Place*) LocalStateVariables[8];
  UpdateDoIt.Ch2_State = (channelState*) LocalStateVariables[12];
  UpdateDoIt.SystemPfd = (ExtendedPlace<double>*) LocalStateVariables[13];
  UpdateDoIt.FR_Definition = (FR_Array*) LocalStateVariables[10];
}
void system_stateSAN::assignPlacesToActivitiesTimed(){
  Demand_Rate_case1.SystemFailure = (Place*) LocalStateVariables[7];
  Demand_Rate_case1.Demands_Enabled = (Place*) LocalStateVariables[6];
  Demand_Rate_case1.SystemPfd = (ExtendedPlace<double>*) LocalStateVariables[13];
  Demand_Rate_case2.SystemFailure = (Place*) LocalStateVariables[7];
  Demand_Rate_case2.SystemPfd = (ExtendedPlace<double>*) LocalStateVariables[13];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================Set_FRsActivity========================*/


system_stateSAN::Set_FRsActivity::Set_FRsActivity(){
  ActivityInitialize("Set_FRs",1,Instantaneous , RaceEnabled, 11,1, false);
}

void system_stateSAN::Set_FRsActivity::LinkVariables(){
  FR_Init->Register(&FR_Init_Mobius_Mark);
  Init_Ch1->Register(&Init_Ch1_Mobius_Mark);
  Init_Ch2->Register(&Init_Ch2_Mobius_Mark);
  Ch2_slave->Register(&Ch2_slave_Mobius_Mark);





  Mutex->Register(&Mutex_Mobius_Mark);

}

bool system_stateSAN::Set_FRsActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(FR_Init_Mobius_Mark)) >=1));
  return NewEnabled;
}

double system_stateSAN::Set_FRsActivity::Weight(){ 
  return 1;
}

bool system_stateSAN::Set_FRsActivity::ReactivationPredicate(){ 
  return false;
}

bool system_stateSAN::Set_FRsActivity::ReactivationFunction(){ 
  return false;
}

double system_stateSAN::Set_FRsActivity::SampleDistribution(){
  return 0;
}

double* system_stateSAN::Set_FRsActivity::ReturnDistributionParameters(){
    return NULL;
}

int system_stateSAN::Set_FRsActivity::Rank(){
  return 1;
}

BaseActionClass* system_stateSAN::Set_FRsActivity::Fire(){
  (*(FR_Init_Mobius_Mark))--;
  int i=0,j,k,count,found,id;
for(i=0;i<21;i++)
  {
    FR_Definition->Index(i)->ID->Mark() = i;
    FR_Definition->Index(i)->pfd_size->Mark() = FR_init_pfd + FR_increment * i;
  }
for(i=21;i<100;i++)
  {
    FR_Definition->Index(i)->ID->Mark() = i;
    FR_Definition->Index(i)->pfd_size->Mark() = FR_other_pfd;
  };
// Initialise the channels
Ch1_State->channel_ID->Mark() = 0;
Ch2_State->channel_ID->Mark() = 1;
Ch1_State->commonFailurePfd->Mark() = common_pfd;
Ch2_State->commonFailurePfd->Mark() = common_pfd;
SystemPfd->Mark() = common_pfd;
// Now initialise the arrays that belong to channel states
for(i=0;i<20;i++)
  {
    Ch1_State->attacksApplied->Index(i)->ID->Mark() = 0;
    for(j=0;j<10;j++)
      {
	Ch1_State->attacksApplied->Index(i)->FR_set->Index(j)->Mark() = 0;
      }
    Ch2_State->attacksApplied->Index(i)->ID->Mark() = 0;
    for(j=0;j<10;j++)
      {
	Ch2_State->attacksApplied->Index(i)->FR_set->Index(j)->Mark() = 0;
      }
  };
for(i=0;i<100;i++)
  {
    Ch1_State->FR_List->Index(i)->Mark() = 0;
    Ch2_State->FR_List->Index(i)->Mark() = 0;
  };
Ch1_State->channel_ID->Mark() = 0;
Ch2_State->channel_ID->Mark() = 1;
//
// Create the entire List of malicious demands.
//
// ==== Channel 1 =======
cout << "\n\n==== Channel 1 malicious demands =======";
Ch1_attack_list->ChannelID->Mark() = 0;
static UserDistributions dist(0, 31415);
for(i=0;i<20;i++)
  {
    count = (int)(dist.Uniform(1.0,(double)(malicious_demand_max_FRs)));	// Generate a random number of FRs up to malicious_demand_max_FRs.
    cout << "\nDemand:" << i << " Count:" << count;
    Ch1_attack_list->AttacksApplied->Index(i)->ID->Mark() = i;
    // Initialise also the AttackRate to a non-zero value and successProb to 0. 
    Ch1_attack_list->AttacksApplied->Index(i)->AttackRate->Mark() = demand_default_rate;
    Ch1_attack_list->AttacksApplied->Index(i)->successProb->Mark() = (double)(0.0);
    for(j=0;j<count;j++)
      {
	id = (int)(dist.Uniform(1.0,100.0));
	// Now check if the FR has already been added to the pool for the demnd
	found = 0;
	for(k=0;k<j;k++)
	  {
	    if(id == Ch1_attack_list->AttacksApplied->Index(i)->FR_set->Index(k)->Mark())
	      {
		found = 1;
		break;
	      }
	  };
	if(found == 1)
	  {
	    cout << "\n   Id:" << id << " is a repeat. Skipped!";
	    j--;
	  }
	else
	  {
            cout << "\n   Id:" << id;
	    Ch1_attack_list->AttacksApplied->Index(i)->FR_set->Index(j)->Mark() = id;
	  }
      };
    // Sort the FRs that belong to the current demand.
    do
      {
	k = 0;
        for(j=0;j<count-1;j++)
          {
	    if(Ch1_attack_list->AttacksApplied->Index(i)->FR_set->Index(j)->Mark() > Ch1_attack_list->AttacksApplied->Index(i)->FR_set->Index(j+1)->Mark())
	      {
	         found = Ch1_attack_list->AttacksApplied->Index(i)->FR_set->Index(j+1)->Mark();
	         Ch1_attack_list->AttacksApplied->Index(i)->FR_set->Index(j+1)->Mark() = Ch1_attack_list->AttacksApplied->Index(i)->FR_set->Index(j)->Mark();
	         Ch1_attack_list->AttacksApplied->Index(i)->FR_set->Index(j)->Mark() = found;
	         k = 1;
	      }
          };
      } while(k == 1); 
    // List the sorted list
    cout << "\n Demand: " << i << " sorted";
    for(j=0;j<count;j++)
      {
	 cout << "\n   ID: " << Ch1_attack_list->AttacksApplied->Index(i)->FR_set->Index(j)->Mark();
      };
  };
//
// Now check if lists different
Ch2_attack_list->ChannelID->Mark() = 1;
if(isAttackListTheSame == 1)
  {
    // Here merely copy Ch1_attack_list to Ch2_attack_list
    for(i=0;i<20;i++)
      {
	Ch2_attack_list->AttacksApplied->Index(i)->ID->Mark() = Ch1_attack_list->AttacksApplied->Index(i)->ID->Mark();
	Ch2_attack_list->AttacksApplied->Index(i)->AttackRate->Mark() = Ch1_attack_list->AttacksApplied->Index(i)->AttackRate->Mark();
	Ch2_attack_list->AttacksApplied->Index(i)->successProb->Mark() = Ch1_attack_list->AttacksApplied->Index(i)->successProb->Mark();
	for(j=0;j<10;j++)
	  {
	    Ch2_attack_list->AttacksApplied->Index(i)->FR_set->Index(j)->Mark() = Ch1_attack_list->AttacksApplied->Index(i)->FR_set->Index(j)->Mark();
	  };
      };
  }
else
  {
    // Here generate a new list
    cout << "\n\n==== Channel 2 malicious demands =======";
    static UserDistributions dist(0, 31415);
    for(i=0;i<20;i++)
      {
    	count = (int)(dist.Uniform(1.0,(double)(malicious_demand_max_FRs)));	// Generate a random number of FRs up to malicious_demand_max_FRs.
    	cout << "\nDemand:" << i << " Count:" << count;
    	Ch2_attack_list->AttacksApplied->Index(i)->ID->Mark() = i;
    	// Initialise also the AttackRate to a non-zero value and successProb to 0. 
    	Ch2_attack_list->AttacksApplied->Index(i)->AttackRate->Mark() = demand_default_rate;
    	Ch2_attack_list->AttacksApplied->Index(i)->successProb->Mark() = (double)(0.0);
    	for(j=0;j<count;j++)
      	  {
	    id = (int)(dist.Uniform(1.0,100.0));
	    // Now check if the FR has already been added to the pool for the demnd
	    found = 0;
	    for(k=0;k<j;k++)
	      {
	    	if(id == Ch2_attack_list->AttacksApplied->Index(i)->FR_set->Index(k)->Mark())
	      	  {
		    found = 1;
		   break;
	          }
	      };
	    if(found == 1)
	      {
	    	cout << "\n   Id:" << id << " is a repeat. Skipped!";
	    	j--;
	      }
	    else
	      {
            	cout << "\n   Id:" << id;
	    	Ch2_attack_list->AttacksApplied->Index(i)->FR_set->Index(j)->Mark() = id;
	      }
      	  };
    	// Sort the FRs that belong to the current demand.
    	do
	  {
	    k = 0;
            for(j=0;j<count-1;j++)
              {
	    	if(Ch2_attack_list->AttacksApplied->Index(i)->FR_set->Index(j)->Mark() > Ch2_attack_list->AttacksApplied->Index(i)->FR_set->Index(j+1)->Mark())
	      	  {
	            found = Ch2_attack_list->AttacksApplied->Index(i)->FR_set->Index(j+1)->Mark();
	            Ch2_attack_list->AttacksApplied->Index(i)->FR_set->Index(j+1)->Mark() = Ch2_attack_list->AttacksApplied->Index(i)->FR_set->Index(j)->Mark();
	            Ch2_attack_list->AttacksApplied->Index(i)->FR_set->Index(j)->Mark() = found;
	            k = 1;
	      	  }
              };
      	  } while(k == 1); 
    	// List the sorted list
    	cout << "\n Demand: " << i << " sorted";
    	for(j=0;j<count;j++)
	  {
	    cout << "\n   ID: " << Ch2_attack_list->AttacksApplied->Index(i)->FR_set->Index(j)->Mark();
      	  };
      };
  }
// 
Mutex->Mark() = 1;	// Activate mutex
cout << "\n=============\nNEW BATCH\n=============\n";

  (*(Init_Ch1_Mobius_Mark))++;
  (*(Init_Ch2_Mobius_Mark))++;
  (*(Ch2_slave_Mobius_Mark))++;
  return this;
}

/*======================UpdateDoItActivity========================*/


system_stateSAN::UpdateDoItActivity::UpdateDoItActivity(){
  ActivityInitialize("UpdateDoIt",2,Instantaneous , RaceEnabled, 7,1, false);
}

void system_stateSAN::UpdateDoItActivity::LinkVariables(){
  SysUpdate->Register(&SysUpdate_Mobius_Mark);
  UpdateCounter->Register(&UpdateCounter_Mobius_Mark);

  channelAttacked->Register(&channelAttacked_Mobius_Mark);



}

bool system_stateSAN::UpdateDoItActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(SysUpdate_Mobius_Mark)) >=1));
  return NewEnabled;
}

double system_stateSAN::UpdateDoItActivity::Weight(){ 
  return 1;
}

bool system_stateSAN::UpdateDoItActivity::ReactivationPredicate(){ 
  return false;
}

bool system_stateSAN::UpdateDoItActivity::ReactivationFunction(){ 
  return false;
}

double system_stateSAN::UpdateDoItActivity::SampleDistribution(){
  return 0;
}

double* system_stateSAN::UpdateDoItActivity::ReturnDistributionParameters(){
    return NULL;
}

int system_stateSAN::UpdateDoItActivity::Rank(){
  return 1;
}

BaseActionClass* system_stateSAN::UpdateDoItActivity::Fire(){
  (*(SysUpdate_Mobius_Mark))--;
  double commonPfd_increment = (double)(0.0);
double dum_double;
int i,j,k;
int attack_count_1 = 0, attack_count_2 = 0;
//
cout << "\n\n*****UpdateGate: " << "\nCh1 sys update";
//
// This gate is entered once the channel states have been updated, but commonPfd 
// must be updated, too.
// First make sure that the commonFailurePfd in the channels is the same and if not, use the value by channel_Attacked channel.
if(Ch1_State->commonFailurePfd->Mark() != Ch1_State->commonFailurePfd->Mark())
  {
    if(channelAttacked->Mark() == 0)	// Check if the update is caused by channel 1
      Ch2_State->commonFailurePfd->Mark() = Ch1_State->commonFailurePfd->Mark();
    else	// update is caused by channel 2.
      Ch1_State->commonFailurePfd->Mark() = Ch2_State->commonFailurePfd->Mark();
    SystemPfd->Mark() = Ch1_State->commonFailurePfd->Mark();	// Now assign the new value to SystemPfd (does not matter which channel will be used in assignment).
  }
// The algorithm adopted is as follws:
// - channel's commonPfd is in fact the initial commonPfd, which only changes:
//	- at initialisation; 
//	- after patching;
// - SystemPfd is the the current system pfd (which is affected by common FRs in both channels)
// SystemPfd is updated here by looking up for common FRs and setting SystemPfd accordingly.
for (i=0;i<20;i++)
  {
     k = Ch1_State->attacksApplied->Index(i)->ID->Mark();
     if(k != 0)
       {
	 cout << "\nCh 1 Attack applied: " << k << ";      ";
         attack_count_1++;
       }
     k = Ch2_State->attacksApplied->Index(i)->ID->Mark();
     if(k != 0)
       {
         attack_count_2++;
	 cout << "    Ch 2 Attack applied: " << k;
       }
  };
cout << "\nCh1 attack count:" << attack_count_1 << "    Ch2 attack count:" << attack_count_2;
// Now check if any of the channels has attack_count > 0.
if(attack_count_1 == 0)
  {
    // Here clear FR_List
    for(i=0;i<100;i++)
      {
	Ch1_State->FR_List->Index(i)->Mark() = 0;	// Clear the list.
      };
  }
if(attack_count_2 == 0)
  {
    // Here clear FR_List
    for(i=0;i<100;i++)
      {
	Ch2_State->FR_List->Index(i)->Mark() = 0;	// Clear the list.
      };
  }
// Only, if both channels have been attacked may SystemPfd be different from the initial value.
if((attack_count_1 > 0) && (attack_count_2 > 0)) 
  {
    // Now scan the two FR_Lists for common FR IDs. 
    // If one is found, then its size is established by looking it up in FR_Definition
    // and the size is added to commonPfd_increment. 
    // At the end the SystemPfd = Ch1_State->commonFailurePfd + commonPfd_increment;
    for(i=0;i<100;i++)
      {
        if(Ch1_State->FR_List->Index(i)->Mark() == 0)
	  break;
	for(j=0;j<100;j++)
	  {
            if(Ch2_State->FR_List->Index(i)->Mark() == 0)
	      break;
	    if(Ch1_State->FR_List->Index(i)->Mark() == Ch2_State->FR_List->Index(j)->Mark())
	      {
		// Here look up the common FR in FR_Definition
		for(k=0;k<100;k++)
		  {
		     if(Ch1_State->FR_List->Index(i)->Mark() == FR_Definition->Index(k)->ID->Mark())
			{
			  dum_double = FR_Definition->Index(k)->pfd_size->Mark();
			  commonPfd_increment += dum_double;
			  cout << "\nCommon FR ID: " << FR_Definition->Index(k)->ID->Mark() << "    FR size: " << dum_double;
			}
		  };
	      }
	  };
      };
    dum_double = Ch1_State->commonFailurePfd->Mark();
    dum_double += commonPfd_increment;
    cout << "\nBoth attack_1 > 0 AND attack_2 > 0;  New commonFailurePfd = " << dum_double;
    if(dum_double > (double)(1.0))
      {
        dum_double = (double)(1.0);
        cout << " too large. Cap it: commonFailurePfd = " << dum_double;
      }
    SystemPfd->Mark() = dum_double;
  }
else
  {
    dum_double = SystemPfd->Mark();
    cout << "\nOld SystemPfd = " << dum_double;
    dum_double = Ch1_State->commonFailurePfd->Mark();
    cout << "\Neither attack_1 = 0 or attack_2 = 0; Ch1_State.commonFailurePfd = " << dum_double;
    SystemPfd->Mark() = dum_double;
  }
// Now check if any of the channels is down;
if(Ch1_State->isChannelUp->Mark() == 0)
  {
    if(Ch2_State->isChannelUp->Mark() == 0)
      SystemPfd->Mark() = 1;	// Both channels are down;
    else
      SystemPfd->Mark() = Ch2_State->currentPfd->Mark();	// Channel 2 is up only
  }
else
  {
    if(Ch2_State->isChannelUp->Mark() == 0)
      SystemPfd->Mark() = Ch1_State->currentPfd->Mark();	// Channel 1 is up only
    else
      {
	dum_double = SystemPfd->Mark();
        SystemPfd->Mark() = dum_double;		// Do nothing. SystemPfd has been assigned earlier.
      }
  }
;
i = Ch1_State->isChannelUp->Mark();
j = Ch2_State->isChannelUp->Mark();
cout << "\nCh1 status:" << i << "\nCh2 status:" << j << "\n";
commonPfd_increment = Ch1_State->currentPfd->Mark();
cout << "Ch1 current pfd: " << commonPfd_increment << "\n";
commonPfd_increment = Ch2_State->currentPfd->Mark();
cout << "Ch2 current pfd: " << commonPfd_increment << "\n";
commonPfd_increment = SystemPfd->Mark();
cout << "System pfd: " << commonPfd_increment << "\n";
  (*(UpdateCounter_Mobius_Mark))++;
  return this;
}

/*======================Demand_RateActivity_case1========================*/

system_stateSAN::Demand_RateActivity_case1::Demand_RateActivity_case1(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Demand_Rate_case1",0,Deterministic, RaceEnabled, 1,1, false);
}

system_stateSAN::Demand_RateActivity_case1::~Demand_RateActivity_case1(){
  delete[] TheDistributionParameters;
}

void system_stateSAN::Demand_RateActivity_case1::LinkVariables(){
  SystemFailure->Register(&SystemFailure_Mobius_Mark);
  Demands_Enabled->Register(&Demands_Enabled_Mobius_Mark);

}

bool system_stateSAN::Demand_RateActivity_case1::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((SystemFailure->Mark() == 0)));
  return NewEnabled;
}

double system_stateSAN::Demand_RateActivity_case1::DeterministicParamValue(){
  return normal_demands_intervals;
  return 1.0;  // default rate if none is specified
}

double system_stateSAN::Demand_RateActivity_case1::Weight(){ 
  return(1.0 - SystemPfd->Mark());
}

bool system_stateSAN::Demand_RateActivity_case1::ReactivationPredicate(){ 
  return false;
}

bool system_stateSAN::Demand_RateActivity_case1::ReactivationFunction(){ 
  return false;
}

double system_stateSAN::Demand_RateActivity_case1::SampleDistribution(){
  return normal_demands_intervals;
}

double* system_stateSAN::Demand_RateActivity_case1::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int system_stateSAN::Demand_RateActivity_case1::Rank(){
  return 1;
}

BaseActionClass* system_stateSAN::Demand_RateActivity_case1::Fire(){
  ;
  (*(Demands_Enabled_Mobius_Mark))++;
  return this;
}

/*======================Demand_RateActivity_case2========================*/

system_stateSAN::Demand_RateActivity_case2::Demand_RateActivity_case2(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Demand_Rate_case2",0,Deterministic, RaceEnabled, 1,1, false);
}

system_stateSAN::Demand_RateActivity_case2::~Demand_RateActivity_case2(){
  delete[] TheDistributionParameters;
}

void system_stateSAN::Demand_RateActivity_case2::LinkVariables(){
  SystemFailure->Register(&SystemFailure_Mobius_Mark);

}

bool system_stateSAN::Demand_RateActivity_case2::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((SystemFailure->Mark() == 0)));
  return NewEnabled;
}

double system_stateSAN::Demand_RateActivity_case2::DeterministicParamValue(){
  return normal_demands_intervals;
  return 1.0;  // default rate if none is specified
}

double system_stateSAN::Demand_RateActivity_case2::Weight(){ 
  return(SystemPfd->Mark());
}

bool system_stateSAN::Demand_RateActivity_case2::ReactivationPredicate(){ 
  return false;
}

bool system_stateSAN::Demand_RateActivity_case2::ReactivationFunction(){ 
  return false;
}

double system_stateSAN::Demand_RateActivity_case2::SampleDistribution(){
  return normal_demands_intervals;
}

double* system_stateSAN::Demand_RateActivity_case2::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int system_stateSAN::Demand_RateActivity_case2::Rank(){
  return 1;
}

BaseActionClass* system_stateSAN::Demand_RateActivity_case2::Fire(){
  ;
  (*(SystemFailure_Mobius_Mark))++;
  return this;
}

