#include "SW_RewardPVNodes.h"

SW_RewardPV0Worker::SW_RewardPV0Worker():IntervalOfTime(true)
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&system_state1);
}

SW_RewardPV0Worker::~SW_RewardPV0Worker() {
  delete [] TheModelPtr;
}

double SW_RewardPV0Worker::Reward_Function(void) {

return(system_state1->SystemPfd->Mark());

return (0);



}

SW_RewardPV0::SW_RewardPV0(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TheSW_channelRJ);
  double startpts[1]={0.0};
  double stoppts[1]={350.0};
  Initialize("system_pfd",(RewardType)2,1, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("SystemPfd","system_state1");
}

SW_RewardPV0::~SW_RewardPV0() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void SW_RewardPV0::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new SW_RewardPV0Worker;
}
SW_RewardPV1Worker::SW_RewardPV1Worker():IntervalOfTime(true)
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&system_state1);
}

SW_RewardPV1Worker::~SW_RewardPV1Worker() {
  delete [] TheModelPtr;
}

double SW_RewardPV1Worker::Reward_Function(void) {

return(system_state1->Ch1_State->currentPfd->Mark());

return (0);



}

SW_RewardPV1::SW_RewardPV1(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TheSW_channelRJ);
  double startpts[1]={0.0};
  double stoppts[1]={350.0};
  Initialize("ch1_pfd",(RewardType)2,1, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("Ch1_State","system_state1");
}

SW_RewardPV1::~SW_RewardPV1() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void SW_RewardPV1::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new SW_RewardPV1Worker;
}
SW_RewardPV2Worker::SW_RewardPV2Worker():IntervalOfTime(true)
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&system_state1);
}

SW_RewardPV2Worker::~SW_RewardPV2Worker() {
  delete [] TheModelPtr;
}

double SW_RewardPV2Worker::Reward_Function(void) {

return(system_state1->Ch2_State->currentPfd->Mark());

return (0);



}

SW_RewardPV2::SW_RewardPV2(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TheSW_channelRJ);
  double startpts[1]={0.0};
  double stoppts[1]={350.0};
  Initialize("ch2_pfd",(RewardType)2,1, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("Ch2_State","system_state1");
}

SW_RewardPV2::~SW_RewardPV2() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void SW_RewardPV2::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new SW_RewardPV2Worker;
}
SW_RewardPV3Worker::SW_RewardPV3Worker():IntervalOfTime(true)
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&system_state1);
}

SW_RewardPV3Worker::~SW_RewardPV3Worker() {
  delete [] TheModelPtr;
}

double SW_RewardPV3Worker::Reward_Function(void) {

return(system_state1->SystemPfd->Mark());

return (0);



}

SW_RewardPV3::SW_RewardPV3(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TheSW_channelRJ);
  double startpts[8]={0.0, 50.0, 100.0, 150.0, 200.0, 250.0, 300.0, 350.0};
  double stoppts[8]={50.0, 100.0, 150.0, 200.0, 250.0, 300.0, 350.0, 400.0};
  Initialize("sys_pfd_impulse",(RewardType)2,8, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("SystemPfd","system_state1");
}

SW_RewardPV3::~SW_RewardPV3() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void SW_RewardPV3::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new SW_RewardPV3Worker;
}
SW_RewardPV4Worker::SW_RewardPV4Worker():IntervalOfTime(true)
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&system_state1);
}

SW_RewardPV4Worker::~SW_RewardPV4Worker() {
  delete [] TheModelPtr;
}

double SW_RewardPV4Worker::Reward_Function(void) {

return(system_state1->Ch1_State->currentPfd->Mark());

return (0);



}

SW_RewardPV4::SW_RewardPV4(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TheSW_channelRJ);
  double startpts[8]={0.0, 50.0, 100.0, 150.0, 200.0, 250.0, 300.0, 350.0};
  double stoppts[8]={50.0, 100.0, 150.0, 200.0, 250.0, 300.0, 350.0, 400.0};
  Initialize("ch1_pfd_impulse",(RewardType)2,8, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("Ch1_State","system_state1");
}

SW_RewardPV4::~SW_RewardPV4() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void SW_RewardPV4::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new SW_RewardPV4Worker;
}
SW_RewardPV5Worker::SW_RewardPV5Worker():IntervalOfTime(true)
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&system_state1);
}

SW_RewardPV5Worker::~SW_RewardPV5Worker() {
  delete [] TheModelPtr;
}

double SW_RewardPV5Worker::Reward_Function(void) {

return(system_state1->Ch2_State->currentPfd->Mark());

return (0);



}

SW_RewardPV5::SW_RewardPV5(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TheSW_channelRJ);
  double startpts[8]={0.0, 50.0, 100.0, 150.0, 200.0, 250.0, 300.0, 350.0};
  double stoppts[8]={50.0, 100.0, 150.0, 200.0, 250.0, 300.0, 350.0, 400.0};
  Initialize("ch2_pfd_impulse",(RewardType)2,8, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("Ch2_State","system_state1");
}

SW_RewardPV5::~SW_RewardPV5() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void SW_RewardPV5::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new SW_RewardPV5Worker;
}
SW_RewardPV6Worker::SW_RewardPV6Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&system_state1);
}

SW_RewardPV6Worker::~SW_RewardPV6Worker() {
  delete [] TheModelPtr;
}

double SW_RewardPV6Worker::Reward_Function(void) {

return(1.0 - system_state1->SystemFailure->Mark());

return (0);



}

SW_RewardPV6::SW_RewardPV6(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&TheSW_channelRJ);
  double startpts[36]={0.0, 10.0, 20.0, 30.0, 40.0, 50.0, 60.0, 70.0, 80.0, 90.0, 100.0, 110.0, 120.0, 130.0, 140.0, 150.0, 160.0, 170.0, 180.0, 190.0, 200.0, 210.0, 220.0, 230.0, 240.0, 250.0, 260.0, 270.0, 280.0, 290.0, 300.0, 310.0, 320.0, 330.0, 340.0, 350.0};
  double stoppts[36]={0.0, 10.0, 20.0, 30.0, 40.0, 50.0, 60.0, 70.0, 80.0, 90.0, 100.0, 110.0, 120.0, 130.0, 140.0, 150.0, 160.0, 170.0, 180.0, 190.0, 200.0, 210.0, 220.0, 230.0, 240.0, 250.0, 260.0, 270.0, 280.0, 290.0, 300.0, 310.0, 320.0, 330.0, 340.0, 350.0};
  Initialize("MTTF",(RewardType)0,36, startpts, stoppts, timeindex, 0,1, 1);
  AddVariableDependency("SystemFailure","system_state1");
}

SW_RewardPV6::~SW_RewardPV6() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void SW_RewardPV6::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new SW_RewardPV6Worker;
}
